#include <stdio.h>
#include <stdlib.h>
#include <string.h>





static unsigned int get_word(unsigned char *p){
	unsigned int t;
	t = p[1];
	t = ((t << 8) | p[0]);
	return t;
}

static unsigned long get_dword(unsigned char *p){
	unsigned long t;
	t = p[3];
	t = ((t << 8) | p[2]);
	t = ((t << 8) | p[1]);
	t = ((t << 8) | p[0]);
	return t;
}




int main(int argc, char *argv[]){
	unsigned char *src, *head;
	long size, head_size;
	char name[64];
	char *p;

	if(2 > argc){
		exit(0);
	}

	strncpy(name, argv[1], sizeof(name));
	p = strrchr(name, '.');
	if(NULL == p){
		p = (name + strlen(name));
	}

	{
		FILE *fp;

		strcpy(p, ".HED");
		fp = fopen(name, "rb");
		if(NULL == fp){
			printf("%s ݂͑܂\n", name);
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		head_size = ftell(fp);
		head = malloc(head_size);
		if(NULL == head){
			fclose(fp);
			puts("mۂł܂ł");
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(head, 1, head_size, fp);
		fclose(fp);

		strcpy(p, ".CHM");
		fp = fopen(name, "rb");
		if(NULL == fp){
			free(head);
			printf("%s ݂͑܂\n", name);
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = malloc(size);
		if(NULL == src){
			fclose(fp);
			free(head);
			puts("mۂł܂ł");
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}


	{
		FILE *fp;
		long ofs, t_ofs;
		unsigned int t_size;
		int k, num;

		num = (head_size / 8);
		ofs = 0;
		for(k = 0; num > k; ++k){
			t_ofs = get_dword(head + ofs);
			t_size = get_dword(head + ofs + 4);
			if(0 == t_size){
				ofs += 8;
				continue;
			}
			sprintf(p, "_%02d.MDZ", k);
			fp = fopen(name, "wb");
			fwrite((src + t_ofs), 1, t_size, fp);
			fclose(fp);
			ofs += 8;
		}
	}

	free(src);
	free(head);

	exit(0);
}
